/*****************************************
 *                                       *
 *       VGA MODE DEMO PROGRAM           *
 *       640 x 480 x 16 COLOR MODE       *
 *                                       *
 *****************************************/

/*   The basis for this program is from  "Tricks Of The Graphics Gurus" */
/*   by Oliver, Anderson, McCord, Gumas, Zigon.                         */
/*   V. Miller    1997                                                  */

#include <stdio.h>
#include <conio.h>
#include <graphics.h>             /* BGI Graphics Library */

int graphics_driver, graphics_mode;
int i,j,k,icycle,icolor,ncolors_max,nx_max,ny_max,x,y,nx_center,ny_center;
int xlow,xhigh,ylow,yhigh;
void keyboard_input(void);

main ()  {

          graphics_driver=VGA, graphics_mode=VGAHI;        /* select desired driver and mode */
          initgraph(&graphics_driver, &graphics_mode, ""); /* invoke video mode */
          nx_max=640; ny_max=480; ncolors_max=16;          /* VGA VGAHI mode parameters */
          nx_center=nx_max/2; ny_center=ny_max/2;          /* determine screen center x and y */
          cleardevice();                                   /* clear video board */

          for(i=0; i<=nx_max-1; i++)  {                    /* form radial lines */
          xlow=i;
          xhigh=nx_max-1-i;
          moveto(xlow,0);
          icolor=i % ncolors_max;                          /* cycle through color palette */
          setcolor(icolor);
	  lineto(xhigh,ny_max);        }

          for(j=0; j<=ny_max-1; j++)  {                    /* form radial lines */
          ylow=j;
          yhigh=ny_max-1-j;
          moveto(0,ylow);
          icolor=j % ncolors_max;
          setcolor(icolor);                                /* cycle through color palette */
	  lineto(nx_max,yhigh);        }

	  for(j=0; j<= 1500; j++) {                        /* time delay */
	  for(i=0; i<= 8000; i++) {xlow=i*j;}}

	  for(icycle=1; icycle<=2000; icycle++) {
	  if(icycle==100) icycle=1;                        /* restart sequence showing concentric circles with color palette */

          for(j=0; j<=ny_max/2; j++)  {

	  for(i=j; i<=ny_max/2; i++)  {

          x=icycle*i;   y=icycle*j;
	  icolor=(((long)x*x + (long)y*y) >> 12) % ncolors_max ;

          putpixel(nx_center+i, ny_center+j, icolor);
          putpixel(nx_center+i, ny_center-j, icolor);
          putpixel(nx_center-i, ny_center+j, icolor);
          putpixel(nx_center-i, ny_center-j, icolor);
	  putpixel(nx_center+j, ny_center+i, icolor);
	  putpixel(nx_center+j, ny_center-i, icolor);
	  putpixel(nx_center-j, ny_center+i, icolor);
	  putpixel(nx_center-j, ny_center-i, icolor);     } }

          if(icycle==1) {
	  for(j=0; j<= 2000; j++) {                        /* time delay */
          for(i=0; i<= 8000; i++) {xlow=i*j;}}  }

	  keyboard_input();                                 } }

/*--------------------------------------------------------------
        SUBROUTINE: DYNAMIC KEYBOARD INPUT
                                                               */
void keyboard_input(void) {
union u_type{int a; char b[3];}keystroke; char inkey=0;

if(bioskey(1)==0) return;                   /* if no key, return      */
keystroke.a=bioskey(0);                     /* fetch ASCII code...    */
inkey=keystroke.b[0];                       /* ... and load code into variable */
switch (inkey) {                            /* make decision based upon ASCII value */
case 27:  exit(0);                          /* exit on <Esc> key      */
/*case 61:  movez=movez+20; return;  */         /* + key = move outwards  */
/*case 45:  movez=movez-20; return;  */         /* - key = move inwards   */
/*case 104: rd1=rd1-2;      return;  */         /* h key roll right       */
/*case 102: rd1=rd1+2;      return;  */         /* f key roll left        */
/*case 103: rd1=0;rd2=0;rd3=0; return; */       /* g key return to nominal position */
/*case 116: rd2=rd2+2;      return;  */         /* t key pitch forward    */
/*case 98:  rd2=rd2-2;      return;  */         /* b key pitch back       */
/*case 118: rd3=rd3-2;      return;  */         /* v key yaw back         */
/*case 121: rd3=rd3+2;      return;  */         /* y key yaw forward      */

default: return;} }                         /* make routine bullet-proof */

